extern "C" {

#include "prizm.h"
#include "CBP.h"

//-----------------------------------------------------------------------------
// Casio Basic inside
//-----------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------
int ErrorPtr=0;		// Error ptr
int ErrorProg=0;	// Error Prog
int ErrorNo;		// Error No
//----------------------------------------------------------------------------------------------

void ERROR(char *buffer) {
	int key;
	int color=CB_ColorIndex;	// current color index 
	unsigned short bcolor=CB_BackColorIndex;	// current color index 
//	short buf[ 330*(179-30+1) ];
//	short *vram=(short *)PictAry[0];
//	int x,y,i,p;
//	i=0;
//	for( y=30; y<179; y++) {
//		p=26+384*y; for ( x=26; x<355; x++) buf[i++]=vram[p++];
//	}
	if ( TryFlag ) return ;

//	CB_SelectTextDD();	// Select Text Screen
//	SaveDisp(SAVEDISP_PAGE1);
	CB_ColorIndex=-1;	// current color index reset
	CB_BackColorIndex=0xFFFF;	// current color index reset
	FkeyClearAll();
//	PopUpWin( 4 );
	MsgBoxPush( 4 );
	locate(3,3); Prints((unsigned char *)buffer);
	locate(3,5); Prints((unsigned char *) "   Press:[EXIT]");

//	Bdisp_PutDisp_DD();

	WaitKeyAC();
	KeyRecover(); 
	while ( 1 ) {
		EnableDisplayStatusArea();
		GetKey_DisableCatalog(&key);
		if ( key == KEY_CTRL_EXIT  ) break ;
		if ( key == KEY_CTRL_AC    ) break ;
		if ( key == KEY_CTRL_RIGHT ) break ;
		if ( key == KEY_CTRL_LEFT  ) break ;
	}
	
//	RestoreDisp(SAVEDISP_PAGE1);
//	Bdisp_PutDisp_DD();
	MsgBoxPop();
//	i=0;
//	for( y=30; y<179; y++) {
//		p=26+384*y; for ( x=26; x<355; x++) vram[p++]=buf[i++];
//	}
	CB_ColorIndex=color;	// current color index restore
	CB_BackColorIndex=bcolor;	// current color index restore
}

void CB_ErrMsg(int ErrNo) {
	switch (ErrNo) {
		case SyntaxERR:
			ERROR(" Syntax ERROR");
			break;
		case MathERR:
			ERROR(" Ma ERROR");
			break;
		case GoERR:
			ERROR(" Go ERROR");
			break;
		case NestingERR:
			ERROR(" Nesting ERROR");
			break;
		case StackERR:
			ERROR(" Stack ERROR");
			break;
		case MemoryERR:
			ERROR(" Memory ERROR");
			break;
		case ArgumentERR:
			ERROR(" Argument ERROR");
			break;
		case DimensionERR:
			ERROR(" Dimension ERROR");
			break;
		case RangeERR:
			ERROR(" Range ERROR");
			break;
		case NonRealERR:
			ERROR(" Non-Real ERROR");
			break;
		case TooMuchData:
			ERROR(" Too Much Data");
			break;
		case ComERR:
			ERROR(" Com ERROR");
			break;
		case TransmitERR:
			ERROR(" Transmit ERROR");
			break;
		case ReceiveERR:
			ERROR(" Receive ERROR");
			break;

		case NextWithoutForERR:
			ERROR("Next without For");
			break;
		case ForWithoutNextERR:
			ERROR("For without Next");
			break;
		case WhileWithoutWhileEndERR:
			ERROR("While w/o W.End");
			break;
		case WhileEndWithoutWhileERR:
			ERROR("W.End w/o While");
			break;
		case LpWhileWithoutDoERR:
			ERROR("LpWhile w/o Do");
			break;
		case DoWithoutLpWhileERR:
			ERROR("Do w/o LpWhile");
			break;
		case NotLoopERR:
			ERROR("Not Loop ERROR");
			break;
		case DivisionByZeroERR:
			ERROR("Division By Zero");
			break;
		case UndefinedLabelERR:
			ERROR("Undefined Label");
			break;
		case NotEnoughMemoryERR:
			ERROR("Not enough Memory");
			break;
		case StringTooLongERR:
			ERROR("String Too Long");
			break;
		case NoMatrixArrayERR:
			ERROR("No Matrix array");
			break;
		case ArraySizeERR:
			ERROR("Illegal Ary size");
			break;
		case NotfoundProgERR:
			ERROR("Not found Prog");
			break;
		case TooManyProgERR:
			ERROR("Too many SubProg");
			break;
		case IfWithoutIfEndERR:
			ERROR("If without IfEnd");
			break;
		case ThenWithoutIfERR:
			ERROR("Then without If");
			break;
		case CaseWithoutSwitchERR:
			ERROR("Case w/o Switch  ");
			break;
		case DefaultWithoutSwitchERR:
			ERROR("Default w/o Swtch");
			break;
		case SwitchWithoutSwitchEndERR:
			ERROR("Switch w/o S.End ");
			break;
		case SwitchEndWithoutSwitchERR:
			ERROR("S.End w/o Switch ");
			break;
		case CantFindFileERR:
			ERROR("Can't find file");
			break;
		case ElementSizeERR:
			ERROR("Illegal Element");
			break;
		case AlreadyOpenERR:
			ERROR("Already Opened");
			break;
		case ComNotOpenERR:
			ERROR("Com Not Opened");
			break;
		case TypeMismatchERR:
			ERROR("Type Mismatched");
			break;
		case OutOfDomainERR:
			ERROR("Out of Domain ");
			break;
		case UndefinedVarERR:
			ERROR("Undefined Var.");
			break;
		case UndefinedFuncERR:
			ERROR("Undefined Func.");
			break;
		case NotSupportERR:
			ERROR("Not Supported");
			break;
		case TooManyVarERR:
			ERROR("Exceed Var. limit");
			break;
		case DuplicateDefERR:
			ERROR("Duplicated Def.");
			break;
		case AlignmentERR:
//			ERROR("Alignment ERR");
			ERROR("Address Align ERR");
			break;
		case TryWithoutExceptERR:
			ERROR("Try w/o Except  ");
			break;
		case ExcpetWithoutTryERR:
			ERROR("Except w/o Try  ");
			break;
		case TryEndWithoutTryERR:
			ERROR("TryEnd w/o Try ");
			break;
			
		default:
//		case FileERR:
			ERROR("File ERROR");
			break;
	}
}

//-----------------------------------------------------------------------------
void CB_Error(int ErrNo) { // error
	if ( ErrorNo ) return ;
	ErrorNo=ErrNo;
	ErrorPtr=ExecPtr;
	ErrorProg=ProgNo;
	if ( ErrNo==MathERR ) ErrorPtr--;
}

}
